'-----------------------------------------------------
'Ansteuereungsbeispiel fr CC2Net-RAM-Interface Ports
'und SR-LCD-Interface-Platine(Adv.CC1-Appl.Board)
'und Onboard SR-LCD-Interface des Adv.CC1-Appl.Boards
'CCTools 2002 cctools.hs-control.de (19.01.2003)
'-----------------------------------------------------
define DS    Port[9]
define RAMSH Port[10]
define RAMST Port[11]
define RAMWE Port[16]

define cmd byte[2]
define addr word[2]
define LCDCMD word[3]

define dslcd port[10]
define shclk port[9]
define stclk port[12]

define i byte[5]

define SRPorts byte[24]
define RS Bit[185]
define LCDLight Bit[187]
define SRPort1 Bit[188]
define SRPort2 Bit[189]
define SRPort3 Bit[190]
define SRPort4 Bit[191]
define SRPort5 Bit[192]

define LCD_RS_0 &B10 : define LCD_RS_1 &B11 :define LCD_nowrite &B0

'ASCII
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD

'LCD-Einsprungadressen
define LCD_Send &h193
define LCD_SetP &h1c0
define prnLCD &h1e2


'RAM-Einsprung-Adressen & Variablen & Konstanten
define READbyte &h113 : define READword &h119
define WRITEbyte &h109 : define WRITEword &h101
define deselect &b00011110
define control Byte[1] 'Register fr I/O-Ports, CS-Leitungen und Bit17(RAM-Addr)
define bit16 Bit[1]
define CS1 Bit[2] 'Chip-Select: Lo=selected, Hi=deselected
define CS2 Bit[3]
define CS3 Bit[4]
define CS4 Bit[5]


SRPorts=0
gosub RAM_Init
gosub LCD_Init
LCDLight=ON : gosub setSRPorts
#loop
gosub LCD_CLS
sys prnLCD,LCD_RS_1 or SRPorts : print "CCTools (c)2003";
LCDCMD=Line2 : gosub LCD_CMD
sys prnLCD,LCD_RS_1 or SRPorts : print "CC2Net-RAM-Dev.";
LCDCMD=Line3 : gosub LCD_CMD
sys prnLCD,LCD_RS_1 or SRPorts : print "SRLCD-Interface";
LCDCMD=Line4 : gosub LCD_CMD
sys prnLCD,LCD_RS_1 or SRPorts : print "Init...";

pause 5
gosub LCD_CLS
sys prnLCD,LCD_RS_1 or SRPorts : print "Write...";

CS1=0 'RAM 1 selectieren
'ber CS1 bis 4 wird der RAM-Baustein ausgewhlt
'CSx = On od. -1  = Baustein nicht ausgewhlt !
'CSx = Off od. 0  = Baustein ist ausgewhlt !
'Bit16 = On /OFF bzw. 0 / -1 = 17tes Adressbit
'der RAM-Bausteine.
'Bit0 bis Bit15 werden mit sys-Aufruf bergeben(addr)


'RAM Beschreiben mit Adresswert
for addr=0 to 512 step 2
 sys WRITEword,addr,addr
 put 13
 LCDcmd=Line1 : gosub LCD_CMD
 sys prnLCD,LCD_RS_1 or SRPorts : print "Write...";
 LCDCMD=addr : gosub LCD_zahli
next
pause 10

gosub LCD_CLS
sys prnLCD,LCD_RS_1 or SRPorts : print "Read...";
'514 Werte aus dem RAM-Lesen u
for addr = 0 to 512 step 2
 LCDcmd=Line2 : gosub LCD_CMD
 LCDCMD=read_word : gosub LCD_zahli
next

 LCDcmd=Line4 : gosub LCD_CMD
 sys prnLCD,LCD_RS_1 or SRPorts : print "Ready";
gosub RAM_deselect
end


'----RAM-Funktionen--------------------------
#RAM_Init
 control=&hFE
 RAMWE=On
 DS=Off
 RAMSH=Off
 RAMST=Off
return

#READ_byte
sys READbyte,addr,0
return

#READ_word
sys READword,addr,0
return

#RAM_Deselect
control=control or deselect
sys WRITEbyte,0,0
return

'Byte schreiben:
'sys WRITEbyte,addr,Wert

'Word schreiben:
'sys WRITEword, addr,Wert
'Beim Schreiben von Words mu darauf geachtet
'werden, da nur gerade Adressen angegeben werden
'knnen !


'----LCD-Funktionen--------------------------
'Zahlausgaben
#LCD_Zahli ' Integer-Zahl ausgeben
if LCDCMD >= 0 then goto pz
      sys LCD_Send,MINUS,LCD_RS_1 or SRPorts
      LCDCMD=abs(LCDCMD)
      goto nz
    #pz
      sys LCD_Send,SPACE,LCD_RS_1 or SRPorts
#nz
if LCDCMD > 9999 then sys LCD_Send,((LCDCMD/10000)mod 10)+&h30,LCD_RS_1 or SRPorts else sys LCD_Send,&h20,LCD_RS_1 or SRPorts
if LCDCMD > 999 then sys LCD_Send,((LCDCMD/1000)mod 10)+&h30,LCD_RS_1 or SRPorts else sys LCD_Send,&h20,LCD_RS_1 or SRPorts
#LCD_Zahl3 ' 3 stellige Zahl ausgeben
if LCDCMD > 99 then sys LCD_Send,((LCDCMD/100)mod 10)+&h30,LCD_RS_1 or SRPorts else sys LCD_Send,&h20,LCD_RS_1 or SRPorts
#LCD_Zahl2 ' 2 stellige Zahl ausgeben
if LCDCMD > 9 then sys LCD_Send,((LCDCMD/10) mod 10)+&h30,LCD_RS_1 or SRPorts else sys LCD_Send,&h20,LCD_RS_1 or SRPorts
#LCD_Zahl1 ' 1 stellige Zahl ausgeben
sys LCD_Send,(LCDCMD mod 10)+&h30,LCD_RS_1 or SRPorts
return
#LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
sys LCD_Send,(LCDCMD/100)+&h30,LCD_RS_1 or SRPorts
#LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
sys LCD_Send,((LCDCMD/10) mod 10)+&h30,LCD_RS_1 or SRPorts
goto LCD_Zahl1

#LCD_CMD 'Kommando senden
sys LCD_Send,LCDCMD,LCD_RS_0 or SRPorts
return
#LCD_Char 'Zeichen senden
sys LCD_Send,LCDCMD,LCD_RS_1 or SRPorts
return
#LCD_CLS 'LCD lschen
sys LCD_Send,&b00000001,LCD_RS_0 or SRPorts
return
#LCD_Init 'LCD_Initialisieren
ds=off
shclk=off
stclk=off
sys LCD_setP
sys LCD_Send,&b00111000,LCD_RS_0
sys LCD_Send,&b00001111,LCD_RS_0
sys LCD_Send,&b00000001,LCD_RS_0
sys LCD_Send,&b00001110,LCD_RS_0
return
#setSRports 'Portzustnde an SR-LCD aktualisieren
sys LCD_setP,SRPorts
return

'syscode "rpsrlcd.s19" 'Nur einmal laden, dann auskommentieren !

